package sugg;

import java.io.Reader;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.core.LowerCaseFilter;
import org.apache.lucene.analysis.shingle.ShingleFilter;
import org.apache.lucene.analysis.standard.StandardFilter;
import org.apache.lucene.analysis.standard.StandardTokenizer;
import org.apache.lucene.util.Version;

public class MyAnalyzer extends Analyzer{
	private int maxGram;
	
	private Version matchVersion;
	
	public MyAnalyzer(Version matchVersion, int maxGram) {
		this.matchVersion = matchVersion;
		this.maxGram = maxGram;
	}
	
	public int getMaxGram() {
		return maxGram;
	}
	
	public MyAnalyzer(Version matchVersion) {
		this(matchVersion, 3);	//default: contain 1-gram, 2-gram, 3-gram
	}

	@Override
	protected TokenStreamComponents createComponents(String fieldName, Reader reader) {
		StandardTokenizer tokenizer = new StandardTokenizer(matchVersion, reader);
	    TokenStream tokenStream = null;
	    tokenStream = new StandardFilter(matchVersion, tokenizer);
	    tokenStream = new LowerCaseFilter(matchVersion, tokenStream);
	    //tokenStream = new StopFilter(matchVersion, tokenStream, StopAnalyzer.ENGLISH_STOP_WORDS_SET);
	    //tokenStream = new PorterStemFilter(tokenStream);
	    tokenStream = new ShingleFilter(tokenStream, 2, maxGram);
	    return new TokenStreamComponents(tokenizer, tokenStream);
	}
}
