package sugg.cluster;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import sugg.matrix.SVector;

import java.util.Set;

public class ClusterVector {
	class Cluster{
		double clusterWeight = 0;
		SVector nodeWeightVector = new SVector();
	}

	private Map<Integer, Cluster> vec;
	
	public ClusterVector(SVector nodeVector, int [] nodeClusterArray)
	{
		this.vec = new HashMap<Integer, Cluster>();

		for (Entry<Integer, Double> nodeEntry : nodeVector)
		{
			int nodeId = nodeEntry.getKey();
			int clusterId = nodeClusterArray[nodeId];
			double weight = nodeEntry.getValue();
			
			Cluster cluster = this.getCluster(clusterId);
			cluster.clusterWeight += weight;
			cluster.nodeWeightVector.add(nodeId, weight);
		}
	}
	
	public Set<Integer> keySet()
	{
		return this.vec.keySet();
	}
	
	public double getClusterWeight (int clusterId)
	{
		return this.vec.get(clusterId).clusterWeight;
	}
	
	public SVector getClusterVector (int clusterId)
	{
		return this.vec.get(clusterId).nodeWeightVector;
	}
	
	private Cluster getCluster (int clusterId)
	{
		if (this.vec.containsKey(clusterId) == false)
			this.vec.put(clusterId, new Cluster());
		return this.vec.get(clusterId);
	}
}
