package sugg.invertedindex;

import java.io.IOException;
import java.util.Set;

import org.apache.jdbm.DB;

import sugg.tools.LRUBuffer;
import sugg.tools.Timer;

public abstract class InvertedIndex
{
	protected DB db = null;
	
	protected Timer timer = null;
	protected double cost = 0;
	
	protected LRUBuffer<String, PhraseInfo> buffer;
	
	public InvertedIndex()
	{
		this.timer = new Timer();
		this.cost = 0;
	}
	
	public abstract Set<String> keySet ();
	
	public abstract PhraseInfo get (String phrase) throws IOException;
	
	public abstract void put (String phrase, PhraseInfo phraseInfo) throws IOException;
	
	public abstract int size();
	
	public int getHit()
	{
		return this.buffer.getHit();
	}
	
	public int getMiss()
	{
		return this.buffer.getMiss();
	}

	public double getCost()
	{
		return this.cost;
	}
	
	public abstract void close() throws IOException;
}
