package sugg.invertedindex;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class PhraseInfo implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	public long id;
	public Float idf;
	public Long tfSum;
	public List<Posting> postList;
	
	public PhraseInfo ()
	{
		this.postList = new ArrayList<Posting>();
	}
	
	public void sortPostList()
	{
		Collections.sort(this.postList, new Posting.PostingComparatorDescToTf());
	}
	
	public int getSizeInByte()
	{
		return (2 * Long.SIZE + Float.SIZE + postList.size() * 2 * Integer.SIZE)/Byte.SIZE;
	}
	
	public void print()
	{
		System.out.print("*DEBUG*: ");
		System.out.print("id" + id + " ");
		System.out.print("idf" + idf + " ");
		System.out.print("tfSum" + tfSum + " ");
		for (int i = 0; i != Math.min(10, postList.size()); ++i)
		{
			System.out.print("d" + postList.get(i).getId() + " tf" + postList.get(i).getTf() + " ");
		}
		System.out.println();
	}
}