package sugg.objects;

import java.io.PrintWriter;

public class BCAStat {

	public double cost;
	public double iterCluster;
	public double iterCell;
	public double sortCost;
	public double distCost;
	public double accuCost;
	public double numQueryDist;
	public double numDocDist;
	
	private int numRepeat = 0;
	
	public BCAStat()
	{
		this.cost = 0;
		this.iterCluster = 0;
		this.iterCell = 0;
		this.sortCost = this.distCost = this.accuCost = 0;
		this.numQueryDist = 0;
		this.numDocDist = 0;
	}
	
	public BCAStat(double cost, double iterCluster, double iterCell, double sortCost, double distCost, double accuCost,
			double numQueryDist, double numDocDist)
	{
		this.cost = cost;
		this.iterCluster = iterCluster;
		this.iterCell = iterCell;
		this.sortCost = sortCost;
		this.distCost = distCost;
		this.accuCost = accuCost;
		this.numQueryDist = numQueryDist;
		this.numDocDist = numDocDist;
	}
	
	public void add (BCAStat newStat)
	{
		this.cost += newStat.cost;
		this.iterCluster += newStat.iterCluster;
		this.iterCell += newStat.iterCell;
		this.sortCost += newStat.sortCost;
		this.distCost += newStat.distCost;
		this.accuCost += newStat.accuCost;
		this.numQueryDist += newStat.numQueryDist;
		this.numDocDist += newStat.numDocDist;
		
		this.numRepeat++;
	}
	
	public void avg()
	{
		this.cost /= numRepeat;
		this.iterCluster /= numRepeat;
		this.iterCell /= numRepeat;
		this.sortCost /= numRepeat;
		this.distCost /= numRepeat;
		this.accuCost /= numRepeat;
		this.numQueryDist /= numRepeat;
		this.numDocDist /= numRepeat;
	}
	
	public void write(PrintWriter writer)
	{
		writer.printf("##Cost = %.5f\tsort = %.5f\tdist = %.5f\taccu = %.5f\n", 
				this.cost, this.sortCost, this.distCost, this.accuCost);
		writer.println("##Iter = " + this.iterCluster + "\t" + this.iterCell);
		writer.println("##QueryDist = " + this.numQueryDist + "\tDocDist = " + this.numDocDist);
	}
}
