package sugg.objects;

import java.util.Comparator;

public class ComparablePair<A, B> implements Comparable<ComparablePair<A, B>> {

	public A left;
	public B right;
	
	private Comparator<B> comparator;
	
	public ComparablePair (A left, B right, Comparator<B> comparator)
	{
		this.left = left;
		this.right = right;
		this.comparator = comparator;
	}

	@Override
	public int compareTo(ComparablePair<A, B> other) {
		return this.comparator.compare(this.right, other.right);
	}

}
