package sugg.objects;

public class MBRObject {
	private double minX = Double.MAX_VALUE;
	private double minY = Double.MAX_VALUE;
	private double maxX = Double.MIN_VALUE;
	private double maxY = Double.MIN_VALUE;
	
	public void put(double locx, double locy)
	{
		minX = locx < minX ? locx : minX;
		maxX = locx > maxX ? locx : maxX;
		minY = locy < minY ? locy : minY;
		maxY = locy > maxY ? locy : maxY;
	}
	
	public void print()
	{
		System.out.println(minX + " " + maxX + " " + minY + " " + maxY);
	}
	
	public double maxDist(double locx, double locy)
	{
		if (locx < 0 || locy < 0)
			return 0;
		
		double dx1 = Math.abs(locx - minX);
		double dx2 = Math.abs(locx - maxX);
		double dy1 = Math.abs(locy - minY);
		double dy2 = Math.abs(locy - maxY);
		
		double dx = Math.max(dx1, dx2);
		double dy = Math.max(dy1, dy2);
		return Math.sqrt(dx * dx + dy * dy);
	}
	
	public double minDist(double locx, double locy)
	{
		if (locx < 0 || locy < 0)
			return 0;
		
		double dx1 = locx - minX;
		double dx2 = locx - maxX;
		double dy1 = locy - minY;
		double dy2 = locy - maxY;
		
		boolean insideX = dx1 * dx2 <= 0;
		boolean insideY = dy1 * dy2 <= 0;
		
		dx1 = Math.abs(dx1);
		dx2 = Math.abs(dx2);
		dy1 = Math.abs(dy1);
		dy2 = Math.abs(dy2);
		
		if(insideX == true && insideY == true)
		{
			//inside MBR
			return 0;
		}
		else if(insideX == true && insideY == false)
		{
			return Math.min(dy1, dy2);
		}
		else if(insideX == false && insideY == true)
		{
			return Math.min(dx1, dx2);
		}
		else
		{
			double dx = Math.min(dx1, dx2);
			double dy = Math.min(dy1, dy2);
			return Math.sqrt(dx * dx + dy * dy);
		}
	}
}